#include "zx_adapter.h"
#include "vidsch.h"
#include "vidschi.h"

/* must called sch_mgr->engine_lock locked */
void vidschi_engine_dvfs_power_on(vidsch_mgr_t *sch_mgr)
{
    adapter_t *adapter = sch_mgr->adapter;

    if (!adapter->pwm_level.EnableClockGating || !adapter->pm_caps.pwm_manual)
    {
        return;
    }

    if(!sch_mgr->engine_dvfs_power_on)
    {
        if(!list_empty(&sch_mgr->submitted_task_list) || sch_mgr->last_send_fence_id != sch_mgr->returned_fence_id)
        {
            if(sch_mgr->chip_func->power_clock)
            {
                sch_mgr->chip_func->power_clock(sch_mgr, FALSE);
                sch_mgr->engine_dvfs_power_on = TRUE;
            }
        }
    }
}

void vidschi_try_power_tuning(adapter_t *adapter)
{
    vidschedule_t *schedule = adapter->schedule;

    if (!adapter->pwm_level.EnableClockGating || !adapter->pm_caps.pwm_manual)
    {
        return;
    }

    if(schedule->chip_func->power_tuning)
    {
        schedule->chip_func->power_tuning(adapter);
    }
}


